/**
 * 注入API，主要用于各产品特色的公共API注入，如登出手机银行
 */
import Vue from 'vue'
import bocutil from '@boc/mfe/bocutil'
import dateutil from '@boc/mfe/dateutil'

Vue.use(bocutil)
Vue.use(dateutil)

export default {
  install: function (Vue, options) {
    /**
     * 应用于函数错误回调的登出
       在接口错误回调中增加如下判断，弹框点击确定将执行该方法
       if (err.type === 'Logout Error') {
          return false
       }
     */
    // 跳转原生登录页, X07 add by hanping,2020.6.18
    Vue.bocutil.logout = function () {
      var cplugins = Vue.prototype.c_plugins
      try {
        cplugins && cplugins.commonBridge.goToNative(function (data) {
          console.log('goToNative succeed ...')
        }, function (err) {
          console.log('goToNative failed ...')
        }, {
          page: '2'
        });
      } catch (e) {
        console.log('走catch')
      }
    }
    // 接口失败采集 p2205 add by 梅浩楠
    Vue.bocutil.getSmartpayErruAction = function (err, server) {
      let params = {
        dataType: 'content',
        dataSign: 'iisp_cbsp_apperror',
        errTime: Vue.dateutil.formatDateToString(new Date(), '%Y%m%d%H%M%S'),
        errCode: err.code || '',
        errInfo: err.message || err || '',
        errSystemUrl: server.url,
        errPageName: window.location.hash.includes('?') ? window.location.hash.split('?')[0] : (window.location.hash || 'imaApp'),
        errInterface: server.method
      }
      console.log('uAction：' + JSON.stringify(params))
      document.addEventListener('deviceready', function () {
        if (Vue.prototype && Vue.prototype.c_plugins && Vue.prototype.c_plugins.commonBridge && Vue.prototype.c_plugins.commonBridge.uAction) {
          Vue.prototype.c_plugins.commonBridge.uAction(function (data) {
            console.log('uAction succeed ...')
          }, function (data) {
            console.log('uAction fail ...')
          }, {data: params})
        }
      })
    }

    // 修改智慧付应用版本标识为imaapp P2205
    let u = window.navigator.userAgent
    let s = u.indexOf('imaapp(') > -1 ? u.match(/imaapp\(\S+\)/)[0] : ''
    let index = s.indexOf(')')
    Vue.bocutil.imaAppVersion = u.indexOf('imaapp(') > -1 ? s.substring(7, index) : '3.0.0'
  }
}
